Subject: [PATCH v4] MyFirstContribution: refrain from self-iterating too much

From: Junio C Hamano <[email-masked]>
Date: Thu, 27 Jul 2023 17:43:17 -0700

Finding mistakes in and improving your own patches is a good idea,
but doing so too quickly is being inconsiderate to reviewers who
have just seen the initial iteration and taking their time to review
it.  Encourage new developers to perform such a self review before
they send out their patches, not after.  After sending a patch that
they immediately found mistakes in, they are welcome to comment on
them, mentioning what and how they plan to improve them in an
updated version, before sending out their updates.

Helped-by: Torsten Bögershausen <[email-masked]>
Helped-by: Linus Arver <[email-masked]>
Signed-off-by: Junio C Hamano <[email-masked]>
---

The inter/range-diff with my v3 was totally useless, but here is to
show three minor edits I made to Linus's version I am responding to.

 * Simplify parenthesized "because it may be the case that".

 * As if you were "a" reviewer, as we do not designate "the
   reviewer(s)" to a patch.  Anybody can (volunteer to) be a
   reviewer for a patch, and you can be, too.

 * Stress that a single polished patch that comes later (because it
   took time to polish) is vastly preferred than flurry of "oops
   this is better" updates.

    --- /var/tmp/b	2023-07-27 17:38:56.928040307 -0700
    +++ /var/tmp/a	2023-07-27 17:38:36.100067020 -0700
    @@ -1,7 +1,7 @@
     Please give reviewers enough time to process your initial patch before
     sending an updated version. That is, resist the temptation to send a new
    -version immediately (because it may be the case that others may have
    -already started reviewing your initial version).
    +version immediately, because others may have already started reviewing
    +your initial version.
     
     While waiting for review comments, you may find mistakes in your initial
     patch, or perhaps realize a different and better way to achieve the goal
    @@ -9,7 +9,7 @@
     reviewers as follows:
     
      - If the mistakes you found are minor, send a reply to your patch as if
    -   you were the reviewer and mention that you will fix them in an
    +   you were a reviewer and mention that you will fix them in an
        updated version.
     
      - On the other hand, if you think you want to change the course so
    @@ -26,5 +26,5 @@
     new version of your patch. Rather than seeing the initial version right
     now (followed by several "oops, I like this version better than the
     previous one" patches over 2 days), reviewers would strongly prefer if a
    -single polished version came instead, and that version with fewer
    -mistakes were the only one they would need to review.
    +single polished version came 2 days later instead, and that version with
    +fewer mistakes were the only one they would need to review.

Thanks.

 Documentation/MyFirstContribution.txt | 32 +++++++++++++++++++++++++++
 1 file changed, 32 insertions(+)

diff --git a/Documentation/MyFirstContribution.txt b/Documentation/MyFirstContribution.txt
index ccfd0cb5f3..dd46f751b7 100644
--- a/Documentation/MyFirstContribution.txt
+++ b/Documentation/MyFirstContribution.txt
@@ -1256,6 +1256,38 @@ index 88f126184c..38da593a60 100644
 [[now-what]]
 == My Patch Got Emailed - Now What?
 
+Please give reviewers enough time to process your initial patch before
+sending an updated version. That is, resist the temptation to send a new
+version immediately, because others may have already started reviewing
+your initial version.
+
+While waiting for review comments, you may find mistakes in your initial
+patch, or perhaps realize a different and better way to achieve the goal
+of the patch. In this case you may communicate your findings to other
+reviewers as follows:
+
+ - If the mistakes you found are minor, send a reply to your patch as if
+   you were a reviewer and mention that you will fix them in an
+   updated version.
+
+ - On the other hand, if you think you want to change the course so
+   drastically that reviews on the initial patch would be a waste of
+   time (for everyone involved), retract the patch immediately with
+   a reply like "I am working on a much better approach, so please
+   ignore this patch and wait for the updated version."
+
+Now, the above is a good practice if you sent your initial patch
+prematurely without polish.  But a better approach of course is to avoid
+sending your patch prematurely in the first place.
+
+Please be considerate of the time needed by reviewers to examine each
+new version of your patch. Rather than seeing the initial version right
+now (followed by several "oops, I like this version better than the
+previous one" patches over 2 days), reviewers would strongly prefer if a
+single polished version came 2 days later instead, and that version with
+fewer mistakes were the only one they would need to review.
+
+
 [[reviewing]]
 === Responding to Reviews
 
-- 
2.41.0-470-gbfce02c22f